from mpmath import *
from primelib import *

def reversedict(dict):
	outDict={}
	for key in dict:
		outDict[dict[key]]=key
	return outDict

def loaddict(file=open("C:\\Users\\Bryant\\Documents\\pythondump\\charconv.txt")):
	outDict={}
	for line in file:
		myLine=line.split("\t")
		outDict[myLine[0]]=myLine[1].strip()
	file.close()
	return outDict

def convert(string,codedict):
	outString=""
	myString=string.lower()
	for char in myString:
		if codedict.has_key(char):
			outString=outString+codedict[char]
		else:
			outString=outString+"28"
	return outString

def deconvert(string,decodedict):
	length=0
	tempString=""
	outString=""
	for char in string:
		tempString+=char
		length+=1
		if length==2:
			if decodedict.has_key(tempString):
				outString+=decodedict[tempString]
			else:
				outString+="?"
			length=0
			tempString=""
	return outString


def finde(d,k):
	e=0
	while fmod(fmul(d,e)-1,k)!=0:
		e+=1
	return e

def buildkey(low,high):
	primesList=sundaram(high)
	p=0
	q=0
	d=high+1
	while p<low:
		rand=randint(0,len(primesList)-1)
		p=primesList[rand]
	while q<low or q==p:
		rand=randint(0,len(primesList)-1)
		q=primesList[rand]
	n=fmul(p,q)
	k=fmul(p-1,q-1)
	while gcd(d,k)!=1:
		d=randint(1,q)
	e=finde(d,k)
	return [n,mpf(d),mpf(e)]

def leastresidue(myNo,mod):
	lr=myNo-mod
	while lr>mod:
		lr-=mod
	return lr
	
def numsplitstr(unsplitstr,chop):
	outList=[]
	tempList=[]
	i=0
	while i<len(unsplitstr):
		tempList.append(unsplitstr[i])
		if (i+1)%chop==0:
			outList.append("".join(tempList))
			tempList=[]
		i+=1
		if i==len(unsplitstr) and tempList!=[]:
			outList.append("".join(tempList))
	return outList
	
def encode(block,n,e):
	mp.dps=1000000
	length=len(block)
	myBlock=mpf(block)
	calc=myBlock**mpf(e)
	lr=str(int(fmod(calc,n)))
	while len(lr)<length:
		lr="0"+lr
	return lr
	

def decode(block,n,d):
	mp.dps=1000000
	length=len(block)
	myBlock=mpf(block)
	calc=myBlock**mpf(d)
	lr=str(int(fmod(calc,n)))
	while len(lr)<length:
		lr="0"+lr
	return lr
	

